import type { BaseRecord, Agent } from '@aries-framework/core';
import type { Constructor } from '@aries-framework/core/build/utils/mixins';
declare type BaseRecordAny = BaseRecord<any, any, any>;
declare type RecordClass<R extends BaseRecordAny> = Constructor<R> & {
    type: string;
};
export interface RecordsState<R extends BaseRecordAny> {
    loading: boolean;
    records: R[];
}
export declare const addRecord: <R extends BaseRecordAny>(record: R, state: RecordsState<R>) => RecordsState<R>;
export declare const updateRecord: <R extends BaseRecordAny>(record: R, state: RecordsState<R>) => RecordsState<R>;
export declare const removeRecord: <R extends BaseRecordAny>(record: R, state: RecordsState<R>) => RecordsState<R>;
export declare const recordsAddedByType: <R extends BaseRecordAny>(agent: Agent | undefined, recordClass: RecordClass<R>) => import("rxjs").Observable<R>;
export declare const recordsUpdatedByType: <R extends BaseRecordAny>(agent: Agent | undefined, recordClass: RecordClass<R>) => import("rxjs").Observable<R>;
export declare const recordsRemovedByType: <R extends BaseRecordAny>(agent: Agent | undefined, recordClass: RecordClass<R>) => import("rxjs").Observable<R>;
export {};
